package model;

import config.subConfig.DoorConfig;
import config.subConfig.RoomConfig;
import constant.Constant;

import java.awt.*;

/**
 * @author duh
 * @create 2018/7/18 13:46
 * @email duh@elab-plus.com
 **/
public class Door extends ModuleInAxis {
    private DoorConfig config;
    private Room room;

    @Override
    public void drawSelf(Graphics g) {
        if(null == room || null == config){
            System.out.println("room is null or config is null");
            return;
        }
        // 1. 绘制一条圆弧: 椭圆的外切矩形 左上角坐标为(0, 0), 宽100, 高100,
        //                弧的开始角度为0度, 需要绘制的角度数为-90度,
        //                椭圆右边水平线为0度, 逆时针为正角度, 顺时针为负角度
        System.out.println("begin to draw door");
        Graphics2D g2d = (Graphics2D) g.create();
        g2d.setRenderingHint(RenderingHints.KEY_ANTIALIASING, RenderingHints.VALUE_ANTIALIAS_ON);
        g2d.setColor(Color.RED);
        int x = room.getX()+this.x;
        int y = room.getY()+this.y;
        System.out.println("room x="+room.getX()+",y="+room.getY()+",door x="+x+",y="+y);
        g2d.drawString(x+","+y,x,y);
        int radis = config.getRadis();
        g2d.drawArc(x-radis, y-radis, radis*2, radis*2, 0, 90*config.getOpenDir());
        g2d.drawLine(x,y,x,y-radis);
        g2d.setColor(Color.GRAY);
        // 3. 填充一个扇形
        int kedu = 10;
        for(int i = 1;i<radis*2/kedu;i+=2){
            int curRadis = radis*2-i*kedu;
            g2d.drawArc(x-curRadis/2, y-curRadis/2, curRadis, curRadis, 0, 90*config.getOpenDir());
        }
        g2d.drawString(x+","+y,x-10,y+10);
        //画贴墙边
        int endx = this.x+radis+config.getRightOutLength();
        System.out.println("fillRect length = " + endx);
        g2d.fillRect(room.getX(),room.getY()- Constant.CLOSE_WALL_LINE_WIDTH/2,endx,Constant.CLOSE_WALL_LINE_WIDTH);
        g2d.dispose();
    }


    public DoorConfig getConfig() {
        return config;
    }

    public void setConfig(DoorConfig config) {
        this.config = config;
        x = config.getX();
        y = config.getY();
    }

    public void setRoom(Room room) {
        this.room = room;
        int xUsedLength = x+config.getRadis()+config.getRightOutLength();
        int yUsedLength = config.getRadis();
        room.setBottomLeft(room.getBottomLeft()-xUsedLength);
        room.setLeftLeft(room.getLeftLeft()-yUsedLength);
    }
}
