package utils;

import java.util.ArrayList;
import java.util.List;

/**
 * @author duh
 * @create 2018/7/25 14:53
 * @email duh@elab-plus.com
 **/
public class CalcYizhiArrayUtils {
    private List<Integer> roomLength;
    private List<Integer> oneAlignAllLength;
    private List<Integer> twoAlignAllShortLength;
    private List<Integer> twoAlignAllLongLength;

    public List<List<Integer>> calcYizhiWithOnlyOneTwoAlign(){
        List<List<Integer>> list = new ArrayList<>();
        int totalOneLenth = 0;
        for(int length : oneAlignAllLength){
            totalOneLenth += length;
        }
        int leftForTwo = roomLength.get(2) - totalOneLenth;
        System.out.println("totalOneLenth="+totalOneLenth);
        System.out.println("3nd wall length="+roomLength.get(2));
        int twoShortLength = twoAlignAllShortLength.get(0);
        int twoLongLength = twoAlignAllLongLength.get(0);
        if(leftForTwo>=twoLongLength &&twoLongLength>twoShortLength ){
            System.out.println("可以一字排，长短边皆可，方案如下:");
            //TWO at left
            List<List<Integer>> twoAtLeftShort = addTwoAlignLeft(210);
            list.addAll(twoAtLeftShort);
            List<List<Integer>> twoAtLeftLong = addTwoAlignLeft(211);
            list.addAll(twoAtLeftLong);
            //TWO at rightt
            List<List<Integer>> twoAtRightShort = addTwoAlignRight(220);
            list.addAll(twoAtRightShort);
            List<List<Integer>> twoAtRightLong = addTwoAlignRight(221);
            list.addAll(twoAtRightLong);
        }else if(leftForTwo>=twoShortLength){
            System.out.println("可以一字排，只有短边，方案如下:");
            //TWO at left
            List<List<Integer>> twoAtLeftShort = addTwoAlignLeft(210);
            list.addAll(twoAtLeftShort);
            //TWO at rightt
            List<List<Integer>> twoAtRightShort = addTwoAlignRight(220);
            list.addAll(twoAtRightShort);
        }else {
            System.out.println("totalOneLenth is longer than 3nd wall");
        }
        return list;
    }

    private List<List<Integer>> addTwoAlignRight(int numberCode) {
        List<List<Integer>> twoAtRight = new ArrayList<>();
        List<List<Integer>> oneArray2 = getAllArrayList(oneAlignAllLength.size());
        twoAtRight.addAll(oneArray2);
        for (List<Integer> twoAtLeftItem : twoAtRight){
            twoAtLeftItem.add(numberCode);
        }
        return twoAtRight;
    }

    private List<List<Integer>> addTwoAlignLeft(int numberCode) {
        List<List<Integer>> twoAtLeft = new ArrayList<>();
        List<List<Integer>> oneArray = getAllArrayList(oneAlignAllLength.size());
        twoAtLeft.addAll(oneArray);
        for (List<Integer> twoAtLeftItem : twoAtLeft){
            twoAtLeftItem.add(0,numberCode);
        }
        return twoAtLeft;
    }

    /**
     * 获取n个数的所有组合
     * @param n
     */
    public List<List<Integer>> getAllArrayList(int n){
        List<List<Integer>> arrayList = new ArrayList<>();
        if(n < 1){
            return arrayList;
        }else if(n==1){
            List<Integer> list = new ArrayList<>();
            list.add(n);
            arrayList.add(list);
            return arrayList;
        }
        arrayList = getAllArrayList(n-1);
        for(int index = arrayList.size() -1;index>=0;index--){
            List<Integer> list = arrayList.remove(index);
            for(int i = 0;i<n;i++){
                List<Integer> newList = new ArrayList<>();
                newList.addAll(list);
                newList.add(i,n);
                arrayList.add(newList);
            }
        }
        return arrayList;
    }

    /**
     * 排列数
     * @param n
     * @return
     */
    public int A(int n){
        if(n <= 0){
            return 0;
        }else if(n==1){
            return 1;
        }else {
            return n*A(n-1);
        }
    }

    public List<Integer> getRoomLength() {
        return roomLength;
    }

    public void setRoomLength(List<Integer> roomLength) {
        this.roomLength = roomLength;
    }

    public List<Integer> getOneAlignAllLength() {
        return oneAlignAllLength;
    }

    public void setOneAlignAllLength(List<Integer> oneAlignAllLength) {
        this.oneAlignAllLength = oneAlignAllLength;
    }

    public List<Integer> getTwoAlignAllShortLength() {
        return twoAlignAllShortLength;
    }

    public void setTwoAlignAllShortLength(List<Integer> twoAlignAllShortLength) {
        this.twoAlignAllShortLength = twoAlignAllShortLength;
    }

    public List<Integer> getTwoAlignAllLongLength() {
        return twoAlignAllLongLength;
    }

    public void setTwoAlignAllLongLength(List<Integer> twoAlignAllLongLength) {
        this.twoAlignAllLongLength = twoAlignAllLongLength;
    }
}
